// Copyright (C) 2002, 2003  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.

#ifndef METALIC_TYPEADJ_HH
# define METALIC_TYPEADJ_HH

namespace mlc
{

  /*
    This file defines typeadj, an helper struct that aids ajusting the
    constness or referenceness of a type.
    For instance `oln::typeadj<const int>::mutable_ref' equals `int &'.
  */

  // FIXME: this should be tested somewhere in mlc.

  template < class T > struct typeadj             
  {						
    typedef T mutable_val;			
    typedef const T const_val;			    
    typedef T& mutable_ref;			
    typedef const T& const_ref;			
  };

  template < class T > struct typeadj< T& >       
  {						
    typedef T mutable_val;			
    typedef const T const_val;			    
    typedef T& mutable_ref;			
    typedef const T& const_ref;			
  };

  template < class T > struct typeadj< const T >  
  {						
    typedef T mutable_val;			
    typedef const T const_val;			    
    typedef T& mutable_ref;			
    typedef const T& const_ref;			
  };

  template < class T > struct typeadj< const T& > 
  {						
    typedef T mutable_val;			
    typedef const T const_val;			    
    typedef T& mutable_ref;			
    typedef const T& const_ref;			
  };

} // end of namespace mlc

#endif // ! METALIC_TYPEADJ_HH
