
// Copyright (C) 2001, 2002, 2003  EPITA Research and Development Laboratory
//
// This file is part of the Olena Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License version 2 as published by the
// Free Software Foundation.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// As a special exception, you may use this file as part of a free
// software library without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to
// produce an executable, this file does not by itself cause the
// resulting executable to be covered by the GNU General Public
// License.  This exception does not however invalidate any other
// reasons why the executable file might be covered by the GNU General
// Public License.

#ifndef OLENA_TOPO_INTER_PIXEL_BKD_DIR_ITERHH
# define OLENA_TOPO_INTER_PIXEL_BKD_DIR_ITER_HH

# include <oln/core/abstract/iter.hh>
# include <oln/topo/inter-pixel/internal/dir-iter.hh>

namespace oln {

  namespace topo {

    namespace inter_pixel {
      template<unsigned Dim, class Exact = mlc::final>
      class bkd_dir_iter; // fwd_decl
    }

  }

  template<unsigned Dim, class Exact>
  struct iter_traits<topo::inter_pixel::bkd_dir_iter<Dim, Exact> >
    : public iter_traits<topo::inter_pixel::internal::dir_iter_<Dim, typename
      mlc::exact_vt<topo::inter_pixel::bkd_dir_iter<Dim, Exact>, Exact>::ret> >
  {};

  namespace topo {

    namespace inter_pixel {

      template<unsigned Dim, class Exact>
      class bkd_dir_iter 
	: public internal::dir_iter_<Dim, typename mlc::exact_vt<bkd_dir_iter<Dim, Exact>, Exact>::ret>
      {
      private:
	typedef internal::dir_iter_<Dim, typename mlc::exact_vt<bkd_dir_iter<Dim, Exact>, Exact>::ret> super;
	typedef typename super::dir_type dir_type;

      public:
	bkd_dir_iter() : super(), begin_(internal::dir_traits<Dim>::last()) {}
	bkd_dir_iter(dir_type i) : super(i), begin_(i) {}

	template<class U> 
	U
	operator=(U u) { return super::operator=(u); }

	dir_type
	next()
	{ 
	  return internal::dir_traits<Dim>::prev(this->cur_); 
	}

	dir_type
	begin()
	{
	  return begin_;
	}

      private:
	dir_type begin_;
      };

# define oln_bkd_dir_iter_type(ImgType)		\
oln::topo::inter_pixel::bkd_dir_iter< ImgType::dim >

    } // end of namespace inter_pixel

  } // end of namespace topo

} // end of namespace oln

#endif // ! OLENA_TOPO_INTER_PIXEL_BKD_DIR_ITER_HH
